; Cross-compiled using ACME assembler and Relaunch64
;
; April 9, 2005
; "128 Byte Blues" SID - freakyDNA
;
; Notes:
; - try moving cursor around to change tempo
; - type letters at top of screen to change notes
;
;------------------------------------------------------------------------
; 	    _/_/_/_/_/  _/_/_/_/    _/_/_/_/    _/_/_/    _/_/  _/_/  _/_/  _/_/
; 	   _/_/        _/_/  _/_/  _/_/      _/_/  _/_/  _/_/  _/_/  _/_/  _/_/
; 	  _/_/_/_/    _/_/_/_/    _/_/_/_/  _/_/_/_/_/  _/_/_/_/    _/_/  _/_/
; 	 _/_/        _/_/  _/_/  _/_/      _/_/  _/_/  _/_/  _/_/     _/_/
; 	_/_/        _/_/  _/_/  _/_/_/_/  _/_/  _/_/  _/_/  _/_/     _/_/
; 	
; 	                 _/_/_/_/    _/_/    _/_/    _/_/_/ 
; 	                _/_/  _/_/  _/_/_/  _/_/  _/_/  _/_/
; 	               _/_/  _/_/  _/_/  _/_/_/  _/_/_/_/_/
; 	              _/_/  _/_/  _/_/  _/_/_/  _/_/  _/_/
; 	             _/_/_/_/    _/_/    _/_/  _/_/  _/_/
; 
;
;------------------------------------------------------------------------
; 	          w  w  w  .  f  r  e  a  k  y  d  n  a  .  c  o  m
;------------------------------------------------------------------------

; list of defines for SID
!src "../../acme/ACME_Lib/sid/sid.a"
; compile to
!to "fdna128b.prg"

note_count = $02			; $0
note_val = $fd
cursor_blink = $cd		; 1-14

note_table = $400		; index into screen space
colour_mem = $D800		; colour memory

jiffy = $a2			; 1/60 counter

debug_flag = 0			; no debuggin'

              * = $0801

              !word $080c
              !byte $05, $00
              !byte $97
              !tx "789,8"             		; POKE 789,8 ;set interrupt to $0831
              !byte $0,$0,$0				; as seen in xxlarge in SIDin #7
              
taggit:       !tx "fDNA"

freq_table_hi:
              !8 16,   19, 22, 25, 29,   33,  39,  44
freq_table_lo:
              !8 195, 239, 96, 30, 223, 135, 223, 193
				
;  |      64     |      C-4      |     4291    |      16     |     195     |
;  |      67     |      D#-4     |     5103    |      19     |     239     |
;  |      69     |      F-4      |     5728    |      22     |      96     |
;  |      71     |      G-4      |     6430    |      25     |      30     |
;  |      74     |      A#-4     |     7647    |      29     |     223     |
;  |      80     |      C-5      |     8583    |      33     |     135     |
;  |      83     |      D#-5     |    10207    |      39     |     223     |
;  |      85     |      F-5      |    11457    |      44     |     193     |

freq_table_hi2:               
		!8  22,  26,  29,  31,  33,  44,  59,  53 
freq_table_lo2:
           !8  96, 156, 223, 165, 135, 193,  190  
; top note is a bit out of tune, but allows for tag above
;  |      69     |      F-4      |     5728    |      22     |      96     |
;  |      72     |      G#-4     |     6812    |      26     |     156     |
;  |      74     |      A#-4     |     7647    |      29     |     223     |
;  |      75     |      B-4      |     8101    |      31     |     165     |
;  |      80     |      C-5      |     8583    |      33     |     135     |
;  |      85     |      F-5      |    11457    |      44     |     193     |
;  |      90     |      A#-5     |    15294    |      59     |     190     |

; start is at $0831 
mus_irq:
!if debug_flag=1 { inc $d020 }
		lda #$1F
		sta SID_MODE_VOL		; set volume to max and use LP filter
		
		lda jiffy			; get 1/60 tick
		and cursor_blink		; combine with cursor countdown for tempo modulation
		bne exit

add_lda:			
		lda note_count

		tax
		inc note_count

rotate_note:
		clc				; clear any garbage in carry reg
		lda note_table, x		; get the current note from the table
		rol				; rotate left, carry reg top bit
		adc #0			; add carry to low bit
		sta note_table, x		; restore rotated note
		sta colour_mem, x		; change colours too
		
		and #01			; check if low bit is one
		bne note_up			; go up or down in pitch based on rotated low bit

note_down:
		dec note_val		; one-bit note index down
		bvc do_note			; save a byte over jmp

note_up:
		inc note_val
do_note:
		lda note_val		
		bpl do_key1			; change key if halfway through sequence
		and #07
		eor #16
		bvc do_freq
do_key1:
		and #07			; index into second freq table
do_freq:
		tax
		lda freq_table_hi, x	; stuff low and high freq values
		sta SID_V1_F_HI
		lda freq_table_lo, x
		sta SID_V1_F_LO
				
set_adsr:
		ldy #$F1			; loud with quick release
		sty SID_V1_S_R
				
turn_on_note:
		ldy #$15			; set wave and turn on note
		sty SID_V1_C_REG

exit:
!if debug_flag=1 { dec $d020 }
	      jmp $ea31			; exit interrupt